/* David Leonard, 2003. Public domain. */
/* $Id: StackP.h,v 1.2 2003/04/22 04:59:37 d Exp $ */

#ifndef _StackP_h
#define _StackP_h

#include "Stack.h"

typedef struct {
    XtPointer extension;
} StackClassPart;

typedef struct _StackClassRec {
    CoreClassPart	core_class;
    CompositeClassPart	composite_class;
    StackClassPart	stack_class;
} StackClassRec;

extern StackClassRec stackClassRec;

typedef struct {
    /* resources */
    Pixel			foreground;
    Pixel			highlight;
    StackDropCallbackProc	drop_callback;
    StackSplitCallbackProc	split_callback;
    XtCallbackList		hit_notify;
    XtCallbackList		drop_notify;
    XtGravity			gravity;
    Dimension			v_step_min;
    Dimension			v_step_max;
    Dimension			h_step_min;
    Dimension			h_step_max;
    Pixmap			card_pixmap[128];
    Dimension			highlight_width;
    Dimension			highlight_height;
    Boolean			compact;

    /* private */
    GC				gc;
    GC				highlight_gc;
    Dimension			v_step;		/* actual step being used */
    Dimension			h_step;
    int				card_width[128];
    int				card_height[128];
    int				card_depth[128];
    Boolean			highlighted;
} StackPart;

typedef struct _StackRec {
    CorePart		core;
    CompositePart	composite;
    StackPart		stack;
} StackRec;

#endif /* _StackP_h */
